﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{
    public class BasePlayer
    {
        public int CardNum { get; private set; }
        private List<Card> lstCards;
        private CardGroupFactory cardFactory;
        public List<Card> LstCards
        {
            get { return lstCards; }

            private set { }
        }
        public EnumPlayerType PlayerType { get; private set; }
        public int IntCatchScore { get; private set; }
        public BasePlayer(List<Card>list,EnumPlayerType pType)
        {
            IntCatchScore = -1;
               lstCards = list;
            PlayerType = pType;
            cardFactory = CardGroupFactory.CreateInstance();
            CardNum = 17;
        }

        private bool RemoveCard(List<Card> list)
        {
            foreach (var item in list)
            {
                if (!lstCards.Contains(item))
                {
                    return false;
                }
            }
            foreach (var item in list)
            {
                lstCards.Remove(item);
            }
            return true;
        }

        public  BaseCardGroup SendCard(BaseCardGroup g,List<Card> list)
        {

            var cardGroup = cardFactory.CreateByList(list);

            if (cardGroup != null&&cardGroup.IsBiggerThanOther(g))
            {
                if (RemoveCard(list))
                {

                    return cardGroup;
                }
                else
                {
                    return null;
                }
            }
            else
            {
                return null;
            }

        }

        public BaseCardGroup RandomSendCard(BaseCardGroup g)
        {
            var list = new List<Card>();
            if (g == null)
            {
                list.Add(LstCards[0]);

                return PlayCard(g, list);
            }
            else
            {

                var t = g.GetType();
                if (t == typeof(BaseCardGroup))
                {
                    for (int i = 0; i < this.LstCards.Count; i++)
                    {
                        if (this.LstCards[i].CardNum > g.cardNum)
                        {
                            list.Add(this.LstCards[i]);
                            return PlayCard(g, list);

                        }
                    }
                    return null;

                }
                else
                {
                    return null;
                }
            }

        }

        /// <summary>
        /// 出分
        /// </summary>
        /// <param name="score"></param>
        /// <returns></returns>

        public virtual BaseCardGroup PlayCard(BaseCardGroup g, List<Card> list)
        {
            if (g == null && list == null)
            {
                return null;
            }


            var cardGroup = cardFactory.CreateByList(list);

            if (g != null)//g==null 表示 第一手出牌
            {
                if (cardGroup != null && cardGroup.IsBiggerThanOther(g))
                {
                    if (RemoveCard(list))
                    {
                        CardNum = this.LstCards.Count;
                        return cardGroup;
                    }
                    else
                    {
                        return null;
                    }
                }
                else
                {
                    return null;
                }
            }
            else
            {
                if (RemoveCard(list))
                {
                    CardNum = this.LstCards.Count;
                    return cardGroup;
                }
                else
                {
                    return null;
                }
            }
        }
        
        public virtual int   SendScore(int score)
        {
            if (score > -1 && score < 4)
            {
                IntCatchScore = score;
            }
            else
            {
                IntCatchScore = 0;
            }
            return IntCatchScore;

        }
   
        public bool IsNoCard()
        {
            return lstCards.Count == 0;
        }
        
        public void SetLandlord(List<Card>list)
        {
            this.PlayerType = EnumPlayerType.Landlord;
            lstCards.AddRange(list);
            lstCards.Sort();
            CardNum = 20;
        }
    
        public String GetPlayerTyepName()
        {
            if (this.PlayerType == EnumPlayerType.Landlord)
            {
                return "地主";
            }
            else
            {
                return "贫农";
            }

        }

    }
}
