﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{
    public class BaseCardGroup : IComparable<BaseCardGroup>
    {
        public Card SingleCard { get; private set; }
        List<BaseCardGroup> listGroupCards;
        public int cardNum { get; private set; }
        public List<Card> ListCards { get; set; }
        public int CardLen { get; private set; }


        public BaseCardGroup(List<Card> list)
        {

            this.ListCards = list;
            this.ListCards.Sort();
            cardNum = list[0].CardNum;
            SingleCard = list[0];
            CardLen = list.Count;
        }

        public BaseCardGroup(Card c)
        {
            SingleCard = c;

            cardNum = c.CardNum;

            cardNum = c.CardNum;
            ListCards.Add(c);

        }

        public virtual bool CompareToOther(BaseCardGroup oneC)
        {
            return cardNum > oneC.cardNum;
        }
        public bool IsEqual(BaseCardGroup oneC)
        {
            return cardNum == oneC.cardNum;
        }
        public bool IsEqual(Card oneC)
        {
            return cardNum == oneC.CardNum;
        }
        public virtual bool IsValid()
        {
            if (null != ListCards && ListCards.Count == 1)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        public bool IsBiggerThanOther(BaseCardGroup oneC)
        {
            var bom = oneC as BomGroup;

            var bomThis = this as BomGroup;

            if (bom != null)
            {
                if (bomThis == null)
                    return false;
                else
                {
                    return bomThis.CompareToOther(bom);
                }
            }
            else
            {
                return this.CompareToOther(oneC);
            }

        }

        public int CompareTo(BaseCardGroup obj)
        {
            if (cardNum == obj.cardNum)
            {
                return 0;
            }
            return cardNum - obj.cardNum;
        }
    }


}
