﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{
    /// <summary>
    /// 炸弹飞机带对子
    /// </summary>
    public class BomPlaneWithDoubleGroup : BomPlaneWithNothingGroup
    {
        List<DoubleCardsGroup> LstDoubleGroup;

        public BomPlaneWithDoubleGroup(List<Card> list) : base(list)
        {
            this.CountDui = this.CountG / 8;
            LstDoubleGroup = new List<DoubleCardsGroup>();
        }

        public override bool IsValid()
        {
            if (null == ListCards)
            {
                return false;
            }
            if (CountG < 12 || this.CountG % 8 != 0)
            {
                return false;
            }
            if (CountDui > 3)
            {
                return false;
            }
            int sBomIndex = -1;

            for (int i = 3; i < CountG; i++)
            {
                if (ListCards[i].CardNum == ListCards[i - 1].CardNum
                    && ListCards[i - 2].CardNum == ListCards[i].CardNum
                    && ListCards[i - 3].CardNum == ListCards[i - 2].CardNum)
                {
                    sBomIndex = i - 3;
                    break;
                }
            }
            if (sBomIndex == -1 || sBomIndex % 2 != 0)
            {
                return false;
            }


            for (int i = 1; i < sBomIndex; i += 2)
            {
                LstDoubleGroup.Add(new DoubleCardsGroup(new List<Card>() {

                    ListCards[i],
                    ListCards[i-1]

                }));
            }

            for (int i = sBomIndex + 3; i < sBomIndex + CountDui * 4; i += 4)
            {
                LstBomG.Add(new BomGroup(new List<Card>()
                                                        {
                                                            ListCards[i],
                                                            ListCards[i-1],
                                                            ListCards[i-2],
                                                            ListCards[i-3]
                                                        }));

            }



            for (int i = sBomIndex + CountDui * 4 + 1; i < CountG; i += 2)
            {
                LstDoubleGroup.Add(new DoubleCardsGroup(new List<Card>() {

                    ListCards[i],
                    ListCards[i-1]

                }));
            }


            if (LstBomG.Count == CountDui && LstDoubleGroup.Count == 2 * CountDui)
            {
                foreach (var item in LstBomG)
                {
                    if (!item.IsValid())
                    {
                        return false;
                    }
                }
                foreach (var item in LstDoubleGroup)
                {
                    if (!item.IsValid())
                    {
                        return false;
                    }
                }
                return true;
            }
            else
            {
                return false;
            }

        }


        public override bool CompareToOther(BaseCardGroup oneC)
        {
            var bpwdg = oneC as BomPlaneWithDoubleGroup;

            if (bpwdg == null)
            {
                return false;

            }
            if (this.IsValid() && bpwdg.IsValid())
            {
                return this.LstBomG[0].CompareToOther(bpwdg.LstBomG[0]);
            }
            else
            {
                return false;
            }
        }
    }
}
