﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{
    /// <summary>
    /// 炸弹飞机什么都不带
    /// </summary>
   public  class BomPlaneWithNothingGroup:BaseCardGroup
    {
        public int CountG = 0;
        public int CountDui = 0;
        protected List<BomGroup> LstBomG;
        public BomPlaneWithNothingGroup(List<Card> list) : base(list)
        {
            CountG = list.Count;
            CountDui = CountG / 4;
            LstBomG = new List<BomGroup>();
        }

        public override bool IsValid()
        {
            if (null == ListCards)
            {
                return false;
            }
            if (CountG < 8 || CountG % 4 != 0)
            {
                return false;
            }
            for (int i = 3; i < ListCards.Count; i+=4)
            {
                LstBomG.Add(new BomGroup(new List<Card>()
                {
                    ListCards[i],
                    ListCards[i-1],
                    ListCards[i-2],
                    ListCards[i-3],
                }));
            }
            if (LstBomG.Count != CountDui)
            {
                return false;
            }

            for (int i = 0; i < LstBomG.Count; i++)
            {
                if (!LstBomG[i].IsValid())
                {
                    return false;
                }
            }
            return true;

        }

        public override bool CompareToOther(BaseCardGroup oneC)
        {
            var bpwn = oneC as BomPlaneWithNothingGroup;

            if (bpwn == null)
            {
                return false;
            }

            return base.CompareToOther(oneC);
        }
    }

}
