﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{
    /// <summary>
    /// 炸弹飞机带单张
    /// </summary>
    public class BomPlaneWithSingleGroup : BomPlaneWithNothingGroup
    {
        List<Card> LstSingleCards;

        public BomPlaneWithSingleGroup(List<Card> list) : base(list)
        {
            this.CountDui = this.CountG / 6;
            LstSingleCards = new List<Card>();
        }
        public override bool IsValid()
        {
            if (null == ListCards)
            {
                return false;
            }
            if (CountG < 10 || this.CountG % 6 != 0)
            {
                return false;
            }


            int sBomIdx = -1;

            for (int i = 3; i < CountG; i++)
            {
                if (ListCards[i].CardNum == ListCards[i - 1].CardNum
                    && ListCards[i - 2].CardNum == ListCards[i].CardNum
                    && ListCards[i - 3].CardNum == ListCards[i - 2].CardNum)
                {
                    sBomIdx = i - 3;
                    break;
                }
            }

            if (sBomIdx == -1)
            {
                return false;
            }

            for (int i = 0; i < sBomIdx; i++)
            {
                LstSingleCards.Add(ListCards[i]);
            }

            for (int i = sBomIdx + 3; i < sBomIdx + CountDui * 4; i += 4)
            {
                LstBomG.Add(new BomGroup(new List<Card>()
                { ListCards[i],
                    ListCards[i-1],
                    ListCards[i-2],
                    ListCards[i-3] }));
            }



            for (int i = sBomIdx + CountDui * 4; i < CountG; i++)
            {
                LstSingleCards.Add(ListCards[i]);
            }



            if (LstBomG.Count == CountDui)
            {
                for (int i = 0; i < LstBomG.Count; i++)
                {
                    if (!LstBomG[i].IsValid())
                    {
                        return false;
                    }
                }

                if (LstSingleCards.Count > 6)
                {
                    return false;
                }

                for (int i = 1; i < LstSingleCards.Count; i += 2)
                {
                    if (LstSingleCards[i].CardNum == LstSingleCards[i - 1].CardNum)
                    {
                        return false;
                    }
                }
                return true;
            }
            else
            {
                return false;
            }

        }

        public override bool CompareToOther(BaseCardGroup oneC)
        {
            var bpwsg = oneC as BomPlaneWithSingleGroup;

            if (bpwsg == null)
            {
                return false;
            }

            if (this.IsValid() && bpwsg.IsValid())
            {
                return this.LstBomG[0].CompareToOther(bpwsg.LstBomG[0]);
            }
            else
            {
                return false;
            }
        }
    }
}