﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{
    /// <summary>
    /// 对对链子
    /// </summary>
    public class DoubleSeqGroup : DoubleCardsGroup
    {
        public int DuiZiCount;
        public List<DoubleCardsGroup> ListDbSeqs;


        public DoubleSeqGroup(List<Card> listCards) : base(listCards)
        {
            listCards.Sort();
            DuiZiCount = listCards.Count / 2;
            ListDbSeqs = new List<DoubleCardsGroup>();
            for (int i = 0; i < DuiZiCount; i += 2)
            {
                ListDbSeqs.Add(new DoubleCardsGroup(new List<Card>() { listCards[i], listCards[i + 1] }));
            }
        }


        public override bool IsValid()
        {
            if (null == ListCards)
            {
                return false;
            }
            // ListCards.Sort();

            int tCount = ListCards.Count;

            if (tCount % 2 != 0)
            {
                return false;
            }
            DuiZiCount = tCount / 2;
            if (DuiZiCount < 3)
            {
                return false;
            }

            ListDbSeqs = new List<DoubleCardsGroup>();

            for (int i = 2; i < tCount; i += 2)
            {
                if (ListCards[i + 1].CardNum - ListCards[i - 1].CardNum != 1)
                {
                    return false;
                }
                if (ListCards[i - 1].CardNum - ListCards[i - 2].CardNum != 0)
                {
                    return false;
                }
            }

            return true;

        }

        public override bool CompareToOther(BaseCardGroup oneC)
        {
            var dsg = oneC as DoubleSeqGroup;
            if (dsg == null)
            {
                return false;
            }
            if (DuiZiCount != dsg.DuiZiCount)
            {
                return false;
            }
            if (base.cardNum > dsg.cardNum)
            {
                return true;
            }
            else
            {
                return false;
            }


        }
    }

}
