﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{
    /// <summary>
    /// 四带对
    /// </summary>
   public  class FourWithDoubleGroup:BaseCardGroup
    {
        BomGroup Bom;
        List<DoubleCardsGroup> LstDoubleGroup;
        int CountG = 0;

        public FourWithDoubleGroup(List<Card> list) : base(list)
        {
            CountG = list.Count;
            LstDoubleGroup = new List<DoubleCardsGroup>();
        }

        public override bool IsValid()
        {
            if (null == ListCards)
            {
                return false;
            }

            if (CountG != 8)
            {
                return false;
            }

            int sBomIndex = -1;

            for (int i = 3; i < CountG; i++)
            {
                if (ListCards[i].CardNum == ListCards[i - 1].CardNum
                    && ListCards[i - 2].CardNum == ListCards[i].CardNum
                    &&ListCards[i-3].CardNum==ListCards[i-2].CardNum)
                {
                    sBomIndex = i - 3;
                    break;
                }
            }
            if (sBomIndex == -1||sBomIndex%2!=0)
            {
                return false;
            }


            for (int i = 1; i < sBomIndex; i+=2)
            {
                LstDoubleGroup.Add(new DoubleCardsGroup(new List<Card>() {

                    ListCards[i],
                    ListCards[i-1]

                })) ;
            }
            Bom = new BomGroup(new List<Card>()
            {
                ListCards[sBomIndex],
                ListCards[sBomIndex+1],
                ListCards[sBomIndex+2],
                ListCards[sBomIndex+3]
            });

            for (int i = sBomIndex+5; i < CountG; i+=2)
            {
                LstDoubleGroup.Add(new DoubleCardsGroup(new List<Card>() {

                    ListCards[i],
                    ListCards[i-1]

                }));
            }

            if (Bom != null && LstDoubleGroup.Count == 2)
            {
                if (Bom.IsValid())
                {
                    for (int i = 0; i < LstDoubleGroup.Count; i++)
                    {
                        if (!LstDoubleGroup[i].IsValid())
                        {
                            return false;
                        }
                    }
                    return true;
                }
                else
                {
                    return false;
                }
            }
            else
            {
                return false;
            }


        }

        public override bool CompareToOther(BaseCardGroup oneC)
        {
            var fwdg = oneC as FourWithDoubleGroup;

            if (fwdg == null)
            {
                return false;
            }

            if (this.IsValid() && fwdg.IsValid())
            {
                return this.Bom.CompareToOther(fwdg.Bom);
            }
            else
            {
                return false;
            }
            
        }


    }
}
