﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{
    /// <summary>
    /// 四带二
    /// </summary>
    public class FourWithSingleGroup:BaseCardGroup
    {
        public List<Card> SingleCard;
        public BomGroup Bom;

        int CountG = 0;

        public FourWithSingleGroup(List<Card> list) : base(list)
        {
            CountG = list.Count;
            SingleCard = new List<Card>();
        }

        public override bool IsValid()
        {
            if (ListCards == null)
            {
                return false;
            }
            if (CountG!= 6)
            {
                return false;
            }

            int sBomIdx = -1;

            for (int i = 1; i < CountG; i++)
            {
                if (ListCards[i].CardNum == ListCards[i - 1].CardNum)
                {
                    sBomIdx = i - 1;
                    break;
                }
            }

            if (sBomIdx == -1)
            {
                return false;
            }

            for (int i = 0; i < sBomIdx; i++)
            {
                SingleCard.Add(ListCards[i]);
            }

                Bom = new BomGroup(new List<Card>() { ListCards[sBomIdx], ListCards[sBomIdx + 1], 
                    ListCards[sBomIdx + 2], ListCards[sBomIdx + 3] });

            for (int i = sBomIdx + 4; i < CountG; i++)
            {
                SingleCard.Add(ListCards[i]);
            }



            if (null != Bom && null != SingleCard)
            {
                return Bom.IsValid();
            }
            else
            {
                return false;
            }

        }

        public override bool CompareToOther(BaseCardGroup oneC)
        {
            var fwsg = oneC as FourWithSingleGroup;

            if (fwsg == null)
            {
                return false;
            }

            if (fwsg.IsValid() && this.IsValid())
            {

                return this.Bom.CompareToOther(fwsg.Bom);

            }
            else
            {
                return false;
            }


        }
    }
}
