﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{
    /// <summary>
    /// 飞机带多对子
    /// </summary>
    public class PlaneWithDoubleGroup : BaseCardGroup
    {
        List<ThreeCardGroup> ListThreeGroups;
        List<DoubleCardsGroup> ListDoubles;
        int CountG;
        public PlaneWithDoubleGroup(List<Card> card) : base(card)
        {
            ListThreeGroups = new List<ThreeCardGroup>();
            ListDoubles = new List<DoubleCardsGroup>();
        }
        public override bool IsValid()
        {
            if (ListCards == null)
            {
                return false;
            }
            if (ListCards.Count < 10)
            {
                return false;
            }
            if (ListCards.Count % 5 != 0)
            {
                return false;
            }

            CountG = ListCards.Count / 5;

            int endDoubleIdx = -1;

            for (int i = 2; i < CountG * 2 + 1; i += 2)
            {
                if (ListCards[i - 1].CardNum == ListCards[i - 2].CardNum)
                {
                    if (ListCards[i].CardNum != ListCards[i - 1].CardNum)
                    {
                        endDoubleIdx = i - 1;
                        ListDoubles.Add(new DoubleCardsGroup(new List<Card>() { ListCards[i - 1], ListCards[i - 2] }));
                    }
                }
            }

            if (endDoubleIdx == -1)
            {
                for (int i = 2; i < CountG * 3; i += 3)
                {
                    ListThreeGroups.Add(new ThreeCardGroup(new List<Card>() { ListCards[i], ListCards[i - 1], ListCards[i - 2] }));
                }
                for (int i = CountG * 3 + 1; i < ListCards.Count; i += 2)
                {
                    ListDoubles.Add(new DoubleCardsGroup(new List<Card>() { ListCards[i], ListCards[i - 1] }));
                }

            }
            else if (endDoubleIdx == CountG * 2 - 1)
            {

                for (int i = CountG * 2 + 2; i < ListCards.Count; i += 3)
                {
                    ListThreeGroups.Add(new ThreeCardGroup(new List<Card>() { ListCards[i], ListCards[i - 1], ListCards[i - 2] }));
                }


            }
            else if (endDoubleIdx >= -1 && endDoubleIdx < CountG * 2 - 1)
            {


                for (int i = endDoubleIdx + 3; i < endDoubleIdx + 1 + CountG * 3; i += 3)
                {
                    ListThreeGroups.Add(new ThreeCardGroup(new List<Card>() { ListCards[i], ListCards[i - 1], ListCards[i - 2] }));
                }
                for (int i = endDoubleIdx + 1 + CountG * 3 + 1; i <= ListCards.Count; i += 2)
                {
                    ListDoubles.Add(new DoubleCardsGroup(new List<Card>() { ListCards[i], ListCards[i - 1] }));
                }

            }

            for (int i = 0; i < ListThreeGroups.Count; i++)
            {
                if (!ListThreeGroups[i].IsValid())
                {
                    return false;
                }
            }
            for (int i = 0; i < ListDoubles.Count; i++)
            {
                if (!ListDoubles[i].IsValid())
                {
                    return false;
                }
            }
            return true;
        }

        public override bool CompareToOther(BaseCardGroup oneC)
        {
            var pwdg = oneC as PlaneWithDoubleGroup;
            if (pwdg == null)
            {
                return false;
            }
            if (pwdg.CountG != this.CountG)
            {
                return false;
            }

            return ListThreeGroups[0].CompareToOther(pwdg.ListThreeGroups[0]);
        }
    }
}
