﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{
    /// <summary>
    /// 飞机不带
    /// </summary>
    public class PlaneWithNothingGroup : ThreeCardGroup
    {
        List<ThreeCardGroup> ListThreeGroups;
        int ThreeCounts = 0;
        public PlaneWithNothingGroup(List<Card> list) : base(list)
        {
            ListThreeGroups = new List<ThreeCardGroup>();
        }
        public override bool IsValid()
        {
            if (ListCards == null)
            {
                return false;
            }
            if (ListCards.Count < 6)
            {
                return false;
            }
            if (ListCards.Count % 3 != 0)
            {
                return false;
            }
            for (int i = 3; i < ListCards.Count; i += 3)
            {
                if (ListCards[i].CardNum - ListCards[i - 3].CardNum != 1)
                {
                    return false;
                }
            }
            for (int i = 0; i < ListCards.Count; i += 3)
            {
                ListThreeGroups.Add(new ThreeCardGroup(new List<Card>() { ListCards[i], ListCards[i + 1], ListCards[i + 2] }));
            }
            foreach (var item in ListThreeGroups)
            {
                if (!item.IsValid())
                {
                    return false;
                }
            }
            ThreeCounts = ListThreeGroups.Count;
            return true;
        }

        public override bool CompareToOther(BaseCardGroup oneC)
        {

            var pwn = oneC as PlaneWithNothingGroup;

            if (pwn == null)
            {
                return false;
            }

            if (ThreeCounts != pwn.ThreeCounts)
            {
                return false;
            }


            return base.CompareToOther(((ThreeCardGroup)oneC));
        }
    }
}
