﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{

    /// <summary>
    /// 飞机带单张
    /// </summary>
    public class PlaneWithSingleGroup : BaseCardGroup
    {
        List<Card> SingleCards;
        List<ThreeCardGroup> ListThreeGroups;

        int CountG = 0;

        public PlaneWithSingleGroup(List<Card> list) : base(list)
        {
            SingleCards = new List<Card>();
            ListThreeGroups = new List<ThreeCardGroup>();
        }
        public override bool IsValid()
        {
            if (ListCards == null)
            {
                return false;
            }
            if (ListCards.Count < 8)
            {
                return false;
            }
            if (ListCards.Count % 4 != 0)
            {
                return false;
            }

            CountG = ListCards.Count / 4;

            int endSingleIdx = -1;

            for (int i = 2; i < CountG + 1; i += 2)
            {
                if (ListCards[i - 1].CardNum == ListCards[i - 2].CardNum)
                {
                    if (ListCards[i].CardNum != ListCards[i - 1].CardNum)
                    {
                        return false;
                    }
                }
            }

            for (int i = 1; i < CountG + 1; i += 1)
            {
                if (ListCards[i].CardNum != ListCards[i - 1].CardNum)
                {
                    endSingleIdx = i - 1;
                    SingleCards.Add(ListCards[i - 1]);

                }
            }


            if (endSingleIdx == -1)
            {
                for (int i = CountG * 3 + 2; i < ListCards.Count; i += 1)
                {
                    if (ListCards[i].CardNum == ListCards[i - 1].CardNum)
                    {
                        if (ListCards[i - 2].CardNum != ListCards[i - 1].CardNum)
                        {
                            return false;
                        }
                    }
                }

                for (int i = 2; i < CountG * 3; i += 3)
                {
                    ListThreeGroups.Add(new ThreeCardGroup(new List<Card>()
                    { ListCards[i], ListCards[i - 1], ListCards[i - 2]}));
                }
                for (int i = CountG * 3; i < ListCards.Count; i++)
                {
                    SingleCards.Add(ListCards[i]);
                }


            }
            else if (endSingleIdx == CountG - 1)
            {

                for (int i = CountG + 2; i < ListCards.Count; i += 3)
                {
                    ListThreeGroups.Add(new ThreeCardGroup(new List<Card>() { ListCards[i], ListCards[i - 1], ListCards[i - 2] }));
                }


            }
            else if (endSingleIdx >= -1 && endSingleIdx < CountG - 1)
            {

                for (int i = endSingleIdx + 1 + CountG * 3; i < ListCards.Count; i += 1)
                {
                    if (ListCards[i].CardNum == ListCards[i - 1].CardNum)
                    {
                        if (ListCards[i - 2].CardNum != ListCards[i - 1].CardNum)
                        {
                            return false;
                        }
                    }
                }

                for (int i = endSingleIdx + 3; i < endSingleIdx + 1 + CountG * 3; i += 3)
                {
                    ListThreeGroups.Add(new ThreeCardGroup(new List<Card>() { ListCards[i], ListCards[i - 1], ListCards[i - 2] }));
                }

                for (int i = endSingleIdx + 1 + CountG * 3; i < ListCards.Count; i += 1)
                {
                    SingleCards.Add(ListCards[i]);
                }

            }



            for (int i = 0; i < ListThreeGroups.Count; i++)
            {
                if (!ListThreeGroups[i].IsValid())
                {
                    return false;
                }
            }
            CountG = ListThreeGroups.Count;
            return true;
        }

        public override bool CompareToOther(BaseCardGroup oneC)
        {
            var pwsg = oneC as PlaneWithSingleGroup;
            if (pwsg == null)
            {
                return false;
            }
            if (pwsg.CountG != this.CountG)
            {
                return false;
            }
            if (this.IsValid() && pwsg.IsValid())
            {
                return ListThreeGroups[0].CompareToOther(pwsg.ListThreeGroups[0]);
            }
            else
            {
                return false;
            }
        }
    }
}
