﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{
   public class SingleSeqGroup:BaseCardGroup
    {
        int CountG = 0;
        public SingleSeqGroup(List<Card> list) : base(list)
        {
            CountG = list.Count;
        }
        public override bool IsValid()
        {
            if (ListCards == null)
            {
                return false;
            }

            if (ListCards.Count < 5 && ListCards.Count > 12)
            {
                return false;
            }

            for (int i = 1; i <ListCards.Count; i++)
            {
                if (ListCards[i].CardNum - ListCards[i - 1].CardNum != 1)
                {
                    return false;
                }
            }
            return true;


        }

        public override bool CompareToOther(BaseCardGroup oneC)
        {
            var ssg = oneC as SingleSeqGroup;

            if (ssg == null)
            {
                return false;
            }
            if (ssg.CountG != this.CountG)
            {
                return false;
            }
            return base.CompareToOther(oneC);
        }
    }
}
