﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{
    public class ThreeCardGroup : BaseCardGroup
    {
        public int CardCount;


        public ThreeCardGroup(List<Card> list) : base(list)
        {

        }

        public override bool IsValid()
        {
            if (ListCards == null)
            {
                return false;
            }

            if (ListCards.Count == 3)
            {
                for (int i = 1; i < 3; i++)
                {
                    if (ListCards[i].CardNum - ListCards[i - 1].CardNum != 0)
                    {
                        return false;
                    }
                }
                return true;
            }
            else
            {
                return false;
            }
        }

        public override bool CompareToOther(BaseCardGroup oneC)
        {
            var tcg = oneC as ThreeCardGroup;
            if (tcg == null)
            {
                return false;
            }


            return base.CompareToOther(oneC);
        }

    }

}
