﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{
    /// <summary>
    /// 三带一
    /// </summary>
    public class ThreeWithOneGroup : ThreeCardGroup
    {
        public ThreeCardGroup threeGroup;
        BaseCardGroup bcOne;

        public ThreeWithOneGroup(List<Card> list) : base(list)
        {

        }



        public override bool IsValid()
        {
            if (null == ListCards)
            {
                return false;
            }
            if (ListCards.Count == 4)
            {
                if (ListCards[0].CardNum == ListCards[1].CardNum && ListCards[0].CardNum != ListCards[3].CardNum)
                {
                    threeGroup = new ThreeCardGroup(new List<Card>() { ListCards[0], ListCards[1], ListCards[2] });
                    bcOne = new BaseCardGroup(new List<Card>() { ListCards[3] });
                }
                else if (ListCards[0].CardNum != ListCards[1].CardNum && ListCards[1].CardNum == ListCards[2].CardNum)
                {
                    threeGroup = new ThreeCardGroup(new List<Card>() { ListCards[2], ListCards[2], ListCards[3] });
                    bcOne = new BaseCardGroup(new List<Card>() { ListCards[0] });
                }
                if (threeGroup != null)
                {
                    return threeGroup.IsValid();
                }
                else
                {
                    return false;
                }

            }
            return false;
        }

        public override bool CompareToOther(BaseCardGroup oneC)
        {
            var threeWOne = oneC as ThreeWithOneGroup;
            if (threeWOne == null)
            {
                return false;
            }

            if (this.IsValid() && oneC.IsValid())
            {

                return this.threeGroup.CompareToOther(threeWOne.threeGroup);
            }
            return false;
        }
    }
}
