﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{

    /// <summary>
    /// 三带对
    /// </summary>
    public class ThreeWithTowGroup : ThreeCardGroup
    {
        public DoubleCardsGroup DoubleGCards;
        public ThreeCardGroup ThreeGCards;
        public ThreeWithTowGroup(List<Card> list) : base(list)
        {

        }

        public override bool IsValid()
        {
            if (null == ListCards)
            {
                return false;
            }
            if (ListCards.Count != 5)
            {
                return false;
            }
            // ListCards.Sort();

            if (ListCards[0].CardNum == ListCards[2].CardNum && ListCards[0].CardNum != ListCards[3].CardNum)
            {

                ThreeGCards = new ThreeCardGroup(new List<Card>() { ListCards[0], ListCards[1], ListCards[2] });

                DoubleGCards = new DoubleCardsGroup(new List<Card>() { ListCards[3], ListCards[4] });
            }
            else if (ListCards[0].CardNum != ListCards[2].CardNum && ListCards[2].CardNum == ListCards[3].CardNum)
            {

                ThreeGCards = new ThreeCardGroup(new List<Card>() { ListCards[2], ListCards[3], ListCards[4] });

                DoubleGCards = new DoubleCardsGroup(new List<Card>() { ListCards[0], ListCards[1] });
            }
            if (ThreeGCards != null && DoubleGCards != null)
            {
                return (ThreeGCards.IsValid() && DoubleGCards.IsValid());
            }
            else
            {
                return false;
            }

        }

        public override bool CompareToOther(BaseCardGroup oneC)
        {
            var threeWithTwo = oneC as ThreeWithTowGroup;
            if (threeWithTwo == null)
            {
                return false;
            }
            if (this.IsValid() && oneC.IsValid())
            {
                return this.ThreeGCards.CompareToOther(threeWithTwo.ThreeGCards);
            }
            else
            {
                return false;
            }
        }
    }
}
