﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FightLandloard.Modal
{
    public class GameManage
    {
      public   BasePlayer[] GamePlayer { get; private set; }
        private List<Card> Cards;
        public List<Card> listThree { get; private set; }
        private string[] arr;
        public int IntCallIndex { get; private set; }
        public int IndexCurrentPlayerIndex { get;  set; }
        public int StartTurnIndex;//开始第一手玩家记录下来
        private Type CurrentCardGroupType;
        public int OneTurnSendTimes=0;
        public BaseCardGroup CurrentCardGroup { get;  set; }

        public GameManage()
        {
            GamePlayer = new BasePlayer[3];

            arr = new string[4] { "j", "q", "k", "a" };
            Cards = new List<Card>();

            //CreateCards();
            CurrentCardGroupType = typeof(BaseCardGroup);
            IntCallIndex = 0;
        }

        private void CreateCards()
        {
            Cards.Clear();
            for (int i = 1; i < 5; i++)
            {
                int type = i;

                for (int num = 2; num < 11; num++)
                {
                    Cards.Add(new Card(type, num.ToString()));
                }
                for (int k = 0; k < arr.Length; k++)
                {
                    Cards.Add(new Card(type, arr[k]));
                }

            }
            Cards.Add(new Card(5, "1"));
            Cards.Add(new Card(5, "3"));
        }


        public List<Card> ShuffleCards()
        {
            int currentIndex;
            Card tempValue;
           
            for (int i = Cards.Count - 1; i >= 0; i--)
            {
                Random random = new Random();
                currentIndex = random.Next(0, i + 1);
                tempValue = Cards[currentIndex];
                Cards[currentIndex] = Cards[i];
                Cards[i] = tempValue;
            }
            listThree = new List<Card>();
            listThree.Add(Cards[51]);
            listThree.Add(Cards[52]);
            listThree.Add(Cards[53]);
            
            listThree.Sort();
            return Cards;

        }

        public void DealCard()
        {
            for (int i = 0; i < GamePlayer.Length; i++)
            {
                var list = new List<Card>();

                for (int j = 17 * i; j < 17 * (i + 1); j++)
                {
                    list.Add(Cards[j]);
                }
                list.Sort();
                GamePlayer[i] = new BasePlayer(list, EnumPlayerType.PoorFarmer);
            }


        }

        public void ShufflePalyer()
        {
            Random random = new Random();
            for (int i = 0; i < 10; i++)
            {
                int v1 = random.Next(0, 3);//左闭右开
                int v2 = random.Next(0, 3);//左闭右开

                //3.交换两个数

                var temp = GamePlayer[v2];
                GamePlayer[v2] = GamePlayer[v1];
                GamePlayer[v1] = temp;

            }
        }

        public void DealLandlard()
        {
            if (GamePlayer[0] == null || GamePlayer[1] == null || GamePlayer[2] == null)
            {
                return;
            }
            int[] scores = new int[3];
            
            for (int i= IntCallIndex; i <IntCallIndex+3; i++)
            {
                int score = GamePlayer[i % 3].IntCatchScore;
                scores[i % 3] = score;

            }

            int max = 0;
            int maxIndex = -1;
            for (int i = 0; i < scores.Length; i++)
            {
                if (scores[i] > max)
                {
                    max = scores[i];
                    maxIndex = i;
                }
            }

            if (max == 0)
            {
                Play();
            }
            else
            {
               
                GamePlayer[maxIndex].SetLandlord(listThree);

            }

            IntCallIndex = (IntCallIndex + 1) % 3;
            IndexCurrentPlayerIndex = maxIndex;
            StartTurnIndex = IndexCurrentPlayerIndex;
            IntCallIndex = 0;
        }
        public BasePlayer SetSelfPalyer()
        {
            return GamePlayer[0];
        }
        public BasePlayer SetLeftPalyer()
        {
            GamePlayer[1]= new RobotPlayer(GamePlayer[1]);
            return GamePlayer[1];
        }
        public BasePlayer SetRightPlayer()
        {
            GamePlayer[2]= new RobotPlayer(GamePlayer[2]);
            return GamePlayer[2];
        }
        public BasePlayer ReturnCurrentPalyer()
        {
            return GamePlayer[IndexCurrentPlayerIndex];
        }
        public void Play()
        {
            CreateCards();
            ShuffleCards();
            DealCard();
            ShufflePalyer();
        }

        public void SetSendCardIndex()
        {
            this.IndexCurrentPlayerIndex = (IndexCurrentPlayerIndex + 1) % 3;
        }
        public void SetCurrentGroup(BaseCardGroup g)
        {
            if (g != null)
            {
                this.CurrentCardGroupType = g.GetType();
                this.CurrentCardGroup = g;
                //SetSendCardIndex();

            }
        }
        public BaseCardGroup GetCardGroup()
        {
            return this.CurrentCardGroup;
        }
    
        public void ClearGroup()
        {
            this.CurrentCardGroup = null;
            this.CurrentCardGroupType = null;
        }

        public void SetOneTurnSendTimes()
        {
            OneTurnSendTimes+=1;
        }

        public void SetFirstSendPlayerIndex()
        {
            this.StartTurnIndex = IndexCurrentPlayerIndex;
            this.OneTurnSendTimes =0;
        }
    
        public void DealJiaoFeng(BaseCardGroup g)
        {
            if (g != null)
            {
                return;
            }
            if(OneTurnSendTimes== 2)
            {
                OneTurnSendTimes = 0;
                ClearGroup();
            }

        }

        public bool IsGameEnd(out bool isLandlordWin)
        {
            isLandlordWin = false;
            for (int i = 0; i < this.GamePlayer.Length; i++)
            {
                var p = this.GamePlayer[i];

                if (p.IsNoCard())
                {
                    if (p.PlayerType == EnumPlayerType.Landlord)
                        isLandlordWin= true;
                    else
                    {
                        isLandlordWin= false;
                    }
                    return true;
                  
                }
            }
            return false;
        }

        public void Inital()
        {
            ClearGroup();
            IndexCurrentPlayerIndex = 0;
            IntCallIndex = 0;
            StartTurnIndex = 0;
        }
    }
}
